//---------------------------------------------------
// module  : DisplayHyper.h                         
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

#ifndef DISPLAYHYPER_H
#define DISPLAYHYPER_H

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionHyper.h"
#include "Chrono.h"

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define NCHAR 200
#define TROIS 3

//>AVIRIS IMAGE
#define DEPTH   224 
#define LENGTH  512 
#define WIDTH   614 

//>DEFAULT PAR
#define SZW  30
#define STGR 0.00008
#define NBITER 20       
#define RSBMIN 10


//------------------------------------------------
// CLASSE DISPLAYHYPER -----------------------------
//------------------------------------------------
class DisplayHyper
{
  //--Donnees--
  //-----------
  public:

  //>Matrices Img
  int***   ImgCoul;
  int***   ImgCoulLAB;

  float***  ImgF1;
  float***  ImgCoulf;

  float**   ImgNB;

  float**   Img1;
  float**   Img2;
  float**   Img3;
  float**   Img4;
  float**   Img5;
  float**   Img6;
  float**   Img7;
  float**   Img8;
  float**   Img9;

  float** BandInfo;

  //>Mtx
  short int***  ImgCube;

  //>Parametres <IMG>
  int width,length,depth;

  //>Parametre <VISU>
  int  dpthselect; 

  //>Parametre <ALGO>
  int   SzW;        //TailleWindow
  float StGr;       //StepGradient
  int   NbInit;     //NbInit
  int   NbIter;     //NbIterations

  //>Flag
  int  flag_save;
  int  flag_silent;
  int  flag_visu;
  int  flag_corr;

  //>Utile
  char Name_Img[NCHAR];
  char Extension[NCHAR];  
  char InfoProcess[100*NCHAR];

  //>Mesures Finales
  int   Method;
  int   TimeSec;
  float Correlation; 
  float FeatSep;

  float NrjImg,NrjImgR,NrjImgG,NrjImgB; 
  float NrjImgInit,NrjImgRInit,NrjImgGInit,NrjImgBInit; 
  float Stab,StabR,StabG,StabB;
  int   Buse,BRuse,BGuse,BBuse;
  
  public:
  DisplayHyper();
  ~DisplayHyper();
       
  //>Methodes
  void Display();

 //==========================
 // File>f_DisplayHyper1.cc
 //==========================
  void ConjGradDesc(float**,float**,int,int,short int***,int,int);
  void FillInfoProcess();
  void MultiResConjGradDesc(short int***,int,int,int,int,int,int,float**,int,int);
  void MultiResConjGradDesc(short int***,int,int,int,int,int,int,float**,int,int,float**);
};

#endif 
