//------------------------------------------------------
// module  : FunctionHyper.h
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// quelques fonctions  

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <new>
#include <time.h>

//------------------------------------------------
// CONSTANTES ------------------------------------
//------------------------------------------------
#define PI  3.14159
#define TROIS 3
#define GREY_LEVEL 255

#define MILLE             1000
#define MILLION        1000000
#define DIXMILLIONS   10000000
#define BILLION     1000000000
#define BIGNUMBER    100000000

#define SQUARE(a)  ((a)*(a))
#define CARRE(X) ((X)*(X))
#define MAX(a,b)   (((a)>(b))?(a):(b))
#define MIN(a,b)   (((a)>(b))?(b):(a))


/*------------------------------------------------*/
/* DEFINITIONS -----------------------------------*/
/*------------------------------------------------*/
#define SWAP(a,b) temp=(a);(a)=(b);(b)=temp;
#define ByteSwap5(x) ByteSwap((unsigned char *) &x,sizeof(x))

//------------------------------------------------
// PROTOTYPE -------------------------------------
//------------------------------------------------

//>Matrix Allocation
float*    fmatrix_allocate_1d(int);
float**   fmatrix_allocate_2d(int,int);
float***  fmatrix_allocate_3d(int,int,int);

int*      imatrix_allocate_1d(int);
int**     imatrix_allocate_2d(int,int);
int***    imatrix_allocate_3d(int,int,int);

short int*    simatrix_allocate_1d(int);
short int**   simatrix_allocate_2d(int,int);
short int***  simatrix_allocate_3d(int,int,int);

void  free_fmatrix_1d(float*);
void  free_fmatrix_2d(float**);
void  free_fmatrix_3d(float***,int);

void  free_imatrix_1d(int*);
void  free_imatrix_2d(int**);
void  free_imatrix_3d(int***,int);

void free_simatrix_1d(short int*);
void free_simatrix_2d(short int**);
void free_simatrix_3d(short int***,int);

//>Matrix Gestion
void  CopyMat(int***,float***,int,int,int); 
void  CopyMat(float***,int***,int,int,int); 
void  CopyMat(float**,float**,int,int); 
void  CopyMat(float**,short int**,int,int);
void  Recal(float**,int,int); 
void  Recal(int***,int,int);
void  Recal(float***,int,int);
void  RecalI(float**,int,int,float,float);

float ComputeMean(float**,int,int); 
float ComputeDiff(float**,float**,int,int); 

//>File PGM/PPM
void load_image_ppm(char*,int***,int,int);
void SaveImagePpm(char*,char*,char*,int***,int,int); 
void SaveImagePpm(char*,char*,char*,float***,int,int);

//>LoadHyperspectralImage
void ByteSwap(unsigned char*,int);
void Stat(float**,int,int);
void LoadImgHyperspectral(char*,short int***,int,int,int);
void SelectInfoBands(short int***,int,int,int,int,float**,float);
float RSB_Estimation(short int**,int,int);

//>NonLocalGraph
void ComputeMultiresNonLocalGraphWindow(short int***,int,int,int,int,short int***,int,int,int);
float ComputeTotalVariationL2(float**,int,int,short int***,int);
float ComputeTotalVariationL2Opt(float**,int,int,short int***,int,float);

//>Convergence
float ComputeNorm2(float**,float**,int,int);
float ComputeStabNorm2(float**,float**,int,int);

//>Conjugate Gradient 
void  AddMatrix(float**,float**,float,float**,int,int);
void  NonLocalGGMRFDeriveL2(float**,float**,int,int,short int***,int);
float ComputeBeta(float**,float**,int,int);
void  MultMatrix(float**,float,float**,int,int);
void  InitMatrix(float**,int,int);

//>Gestion Gradient 
void ChooseInitMatrixAmongBand(short int***,int,int,int,int,float**,short int***,int,int*);
void ChooseMultiResInitMatrixAmongBand(short int***,int,int,int,int,float**,short int***,int,int*,int);

//>Gestion Couleur
void MakeColorImg(int***,float**,float**,float**,int,int);
void LABToRGB(float,float,float,float*,float*,float*);
void LABToXYZ(float,float,float,float*,float*,float*);
void XYZToRGB(float,float,float,float*,float*,float*);
void RGBToLAB(float,float,float,float*,float*,float*);
void RGBToXYZ(float,float,float,float*,float*,float*);
void XYZToLAB(float,float,float,float*,float*,float*);
void HSVToRGB(float,float,float,float*,float*,float*);
void RGBToHSV(float,float,float,float*,float*,float*);
void Convert_LAB_TO_RGB(float***,int,int,float***);

//>Validation
float SAM_Valid(float***,short int***,int,int,int,float*); 

//>Gestion Multiresolution
void InterpolDuplicate(short int***,int,int,int,int,float**,int,int,float**,int,int,int,float);


